# Decision Tree Regression (ML\_R\_5)

The final prediction is made by traversing the tree from the root to a leaf node, where the value of the target variable is stored. It is simple to understand and interpret, but can be prone to overfitting, particularly when the tree is deep and the data is noisy.&#x20;

It is most suitable for continuous target variables and it's popularly used in many applications.

## Sample Request

Build a multiple linear regression model named, *"SimpleModel"*

```javascript
{
    "project_id": 1,
    "parent_id": 7,
    "block_id": 8,
    "function_code": "ML_R_5",
    "args": {
        "model_name": "SimpleModel",
        "random_state": 0
    }
}
```

## Building a Decision Tree Regression model

## Decision Tree Regression

<mark style="color:green;">`POST`</mark> `https://autogon.ai/api/v1/engine/start`

#### Request Body

| Name                                             | Type   | Description                                               |
| ------------------------------------------------ | ------ | --------------------------------------------------------- |
| project\_id<mark style="color:red;">\*</mark>    | int    | The `id` of the current project                           |
| block\_id<mark style="color:red;">\*</mark>      | int    | The `id` of the current block                             |
| function\_code<mark style="color:red;">\*</mark> | string | The function code for current block                       |
| parent\_id<mark style="color:red;">\*</mark>     | int    | The `id` of the previous block                            |
| args                                             | object | Block arguments                                           |
| model\_name                                      | String | Name of the model to be used for prediction.              |
| random\_state                                    | int    | Controls the randomness of the estimator (defaults to 0). |

{% tabs %}
{% tab title="200 Statemanagement object" %}

```javascript
{
    "status": "true",
    "message": {
        "id": 8,
        "project": 1,
        "block_id": 8,
        "parent_id": 7,
        "dataset_url": "",
        "x_value_url": "",
        "y_value_url": "",
        "x_train_url": "",
        "y_train_url": "",
        "x_test_url": "",
        "y_test_url": "",
        "output": "{\"SimpleModel\": {\"function_code\": \"ML_R_3\", \"model_url\": ""}}"
    }
}
```

{% endtab %}
{% endtabs %}

{% tabs %}
{% tab title="Python" %}

```
// Some code
```

{% endtab %}

{% tab title="Node" %}

<pre class="language-javascript"><code class="lang-javascript">const project_id = 1
const parent_id = 7
const block_id = 8

decisionTreeRegression= await client.decision_tree_regression(project_id, parent_id, block_id, {
<strong>    model_name: "SimpleModel",
</strong>    random_state: 0
});
</code></pre>

{% endtab %}
{% endtabs %}

## Sample Request

Make predictions with the pre-built model passing an optional test data.

```javascript
{
    "project_id": 1,
    "parent_id": 8,
    "block_id": 9,
    "function_code": "ML_R_5_P",
    "args": {
        "model_name": "SimpleModel",
        "test_data": ""
    }
}
```

## Predicting with Decision Tree Regression

## Decision Tree Regression Predict

<mark style="color:green;">`POST`</mark> `https://autogon.ai/api/v1/engine/start`

#### Request Body

| Name                                          | Type   | Description                                                            |
| --------------------------------------------- | ------ | ---------------------------------------------------------------------- |
| model\_name<mark style="color:red;">\*</mark> | String | Name of previously trained model to be used for prediction             |
| test\_data                                    | String | Input data for prediction. Defaults to `x_train_url` in StateManagment |
| project\_id                                   | int    | ID of the current project                                              |
| block\_id                                     | int    | ID of the current block                                                |
| parent\_id                                    | int    | ID of the previous block                                               |
| function\_code                                | String | Function code for the current block                                    |

{% tabs %}
{% tab title="200: OK Statemanagement object" %}

```javascript
{
    "status": "true",
    "message": {
        "id": 9,
        "project": 1,
        "block_id": 9,
        "parent_id": 8,
        "dataset_url": "",
        "x_value_url": "",
        "y_value_url": "",
        "x_train_url": "",
        "y_train_url": "",
        "x_test_url": "",
        "y_test_url": "",
        "output": "{\"y_pred_url\": ""}"
    }
}
```

{% endtab %}
{% endtabs %}

{% tabs %}
{% tab title="Python" %}

```
// Some code
```

{% endtab %}

{% tab title="Node" %}

```javascript
const project_id = 1
const parent_id = 7
const block_id = 8

decisionTreeRegressionPredict = await client.decision_tree_regression_predict(project_id, parent_id, block_id, {
   model_name: "SimpleModel",
});
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.autogon.ai/autogon-engine-studio/machine-learning/decision-tree-regression-ml_r_5.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
